package lu.tlk.objectdb_test.cmd;

import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferencePolicy;
import org.osgi.service.log.LogService;

import lu.tlk.objectdb_test.api.PersonAdminAPI;
import lu.tlk.objectdb_test.entity.PersonEntity;

@Component(
	immediate = true
	, property = {
		"osgi.command.scope=tlk"
		, "osgi.command.function=savePerson"
	}
	, service = ObjectDBTestCMD.class
)
public class ObjectDBTestCMD {

	@Reference(policy = ReferencePolicy.DYNAMIC)
	private volatile PersonAdminAPI personAdmin;
	
	@Reference private volatile LogService logger;
	
	public void savePerson() {
		PersonEntity personEntity = new PersonEntity();
		personEntity.setFirstname("Alex").setLastname("Weirig");
		
		if (personAdmin != null) {
			personAdmin.savePerson(personEntity);
			System.out.println("person saved");
			logger.log(LogService.LOG_INFO, "person saved");
		} else {
			System.out.println("no admin service injected ...");
			logger.log(LogService.LOG_ERROR, "no admin service injected ...");
		}
	}
}
